package invalid.thexbot.irc;

/**
 * Lists the known channel user status values.
 *
 * @since 0.5.0
 */
public enum ChannelUserStatus {
	/**
	 * Is channel owner (usually ~).
	 *
	 * @since 0.5.0
	 */
	OWNER,
	/**
	 * Is protected/channel admin (usually &, unless no owner, in which case !).
	 *
	 * @since 0.5.0
	 */
	PROTECTED,
	/**
	 * Is channel operator.
	 *
	 * @since 0.5.0
	 */
	CHANOP,
	/**
	 * Is channel half-operator.
	 *
	 * @since 0.5.0
	 */
	HALFOP,
	/**
	 * Has voice.
	 *
	 * @since 0.5.0
	 */
	VOICE;
}
