package invalid.thexbot.protocol.darenetprotocol;

import invalid.thexbot.TheXBot;
import invalid.thexbot.irc.AccountInfo;
import invalid.thexbot.irc.Server;
import invalid.thexbot.irc.User;
import invalid.thexbot.protocol.Message;
import invalid.thexbot.protocol.MessageHandler;
import invalid.thexbot.protocol.Protocol;

public final class ACHandler extends MessageHandler {
	public ACHandler(Protocol p)
	{
		super(p, 2, SourceType.SERVER);
	}

	@Override
	public void handle(User u, Message m)
	{
		throw new UnsupportedOperationException("Handler called for unsupported source.");
	}

	@Override
	public void handle(Server s, Message m)
	{
		User u = TheXBot.em().findUser(m.args[0]);

		if (m.args[1].equals("U")) {
			u.removeMetaData("account");
			u.setShownHost(u.getRealHost());
		} else if (m.args.length > 2 && m.args[1].equals("M")) {
			AccountInfo ai = u.getAccountInfo();
			if (ai == null) {
				ai = new AccountInfo(m.args[2], -1, -1);
			} else {
				ai.setName(m.args[2]);
			}
			u.setMetaData("account", ai);
			this.protocol.hideUserHost(u);
		} else if (m.args.length > 2 && m.args[1].equals("R")) {
			AccountInfo ai = new AccountInfo(m.args[2],
				(m.args.length > 4) ? Integer.parseInt(m.args[4]) : -1,
				(m.args.length > 3) ? Integer.parseInt(m.args[3]) : -1);

			u.setMetaData("account", ai);
			this.protocol.hideUserHost(u);
		}
	}

	@Override
	public void handle(Message m)
	{
		throw new UnsupportedOperationException("Handler called for unsupported source.");
	}
}
