package invalid.thexbot.protocol.darenetprotocol;

import java.util.EnumSet;
import java.util.logging.Level;
import invalid.thexbot.Logger;
import invalid.thexbot.TheXBot;
import invalid.thexbot.irc.Channel;
import invalid.thexbot.irc.ChannelUserStatus;
import invalid.thexbot.irc.Server;
import invalid.thexbot.irc.User;
import invalid.thexbot.protocol.Message;
import invalid.thexbot.protocol.MessageHandler;
import invalid.thexbot.protocol.Protocol;

public final class CHandler extends MessageHandler {
	public CHandler(Protocol p)
	{
		super(p, 1, SourceType.USER);
	}

	@Override
	public void handle(User u, Message m)
	{
		for (final String chan : m.args[0].split(",")) {
			Channel c = TheXBot.em().findChannel(chan);
			if (c != null) {
				Logger.getLogger(CHandler.class.getName()).log(Level.WARNING,
					"Got new C for " + chan + " but it already exists!");
				continue;
			}
			
			c = new Channel(chan, Integer.parseInt(m.args[1]));
			TheXBot.em().addChannel(c);
			c.addUser(u, EnumSet.of(ChannelUserStatus.CHANOP));
			u.join(c);
		}
	}

	@Override
	public void handle(Server s, Message m)
	{
		throw new UnsupportedOperationException("Handler called for unsupported source.");
	}

	@Override
	public void handle(Message m)
	{
		throw new UnsupportedOperationException("Handler called for unsupported source.");
	}
}

