package invalid.thexbot.protocol.darenetprotocol;

import java.util.logging.Level;
import invalid.thexbot.Logger;
import invalid.thexbot.TheXBot;
import invalid.thexbot.irc.Channel;
import invalid.thexbot.irc.Server;
import invalid.thexbot.irc.User;
import invalid.thexbot.protocol.Message;
import invalid.thexbot.protocol.MessageHandler;
import invalid.thexbot.protocol.Protocol;

public final class KHandler extends MessageHandler {
	public KHandler(Protocol p)
	{
		super(p, 3, SourceType.ANY);
	}

	@Override
	public void handle(User u, Message m)
	{
		handle(m);
	}

	@Override
	public void handle(Server s, Message m)
	{
		handle(m);
	}

	@Override
	public void handle(Message m)
	{
		Channel c = TheXBot.em().findChannel(m.args[0]);
		if (c == null) {
			Logger.getLogger(KHandler.class.getName()).log(Level.WARNING,
				"KICK for non-existent channel " + m.args[0]);
			return;
		}
		
		User kickee = TheXBot.em().findUser(m.args[1]);
		if (kickee == null) {
			Logger.getLogger(KHandler.class.getName()).log(Level.WARNING,
				"KICK for non-existent target " + m.args[1]);
			return;
		}
		
		c.removeUser(kickee);
		kickee.part(c);
		if (c.getUsers().isEmpty() && !c.isPersistent()) {
			TheXBot.em().removeChannel(c);
		}
	}
}

