package invalid.thexbot.protocol.darenetprotocol;

import java.util.logging.Level;
import invalid.thexbot.Logger;
import invalid.thexbot.TheXBot;
import invalid.thexbot.irc.Channel;
import invalid.thexbot.irc.Server;
import invalid.thexbot.irc.User;
import invalid.thexbot.protocol.Message;
import invalid.thexbot.protocol.MessageHandler;
import invalid.thexbot.protocol.Protocol;

public final class LHandler extends MessageHandler {
	public LHandler(Protocol p)
	{
		super(p, 0, SourceType.USER);
	}

	@Override
	public void handle(User u, Message m)
	{
		for (final String name : m.args[0].split(",")) {
			Channel c = TheXBot.em().findChannel(name);
			if (c == null) {
				Logger.getLogger(LHandler.class.getName()).log(Level.WARNING,
					"PART for non-existent Channel " + m.args[0]);
				continue;
			}

			c.removeUser(u);
			u.part(c);
			
			if (c.getUsers().isEmpty() && !c.isPersistent()) {
				TheXBot.em().removeChannel(c);
			}
		}
	}

	@Override
	public void handle(Server s, Message m)
	{
		throw new UnsupportedOperationException("Handler called for unsupported source.");
	}

	@Override
	public void handle(Message m)
	{
		throw new UnsupportedOperationException("Handler called for unsupported source.");
	}
}
