package invalid.thexbot.protocol.darenetprotocol;

import java.util.Arrays;
import invalid.thexbot.TheXBot;
import invalid.thexbot.Util;
import invalid.thexbot.irc.Server;
import invalid.thexbot.irc.User;
import invalid.thexbot.protocol.Message;
import invalid.thexbot.protocol.MessageHandler;
import invalid.thexbot.protocol.Protocol;

public final class NHandler extends MessageHandler {
	public NHandler(Protocol p)
	{
		super(p, 2, SourceType.SERVER);
	}

	@Override
	public void handle(User u, Message m)
	{
		// ABAAB N cx 1234567890
		u.setNick(m.args[0]);
		u.setNickTS(Integer.parseInt(m.args[1]));
	}

	@Override
	public void handle(Server s, Message m)
	{
		if (m.args.length < 9) {
			throw new UnsupportedOperationException("Not enough arguments for N from server.");
		}
		
		User u = new User(m.args[m.args.length - 2], m.args[0], Integer.parseInt(m.args[2]),
			m.args[3], m.args[3],
			Util.base64toip(m.args[m.args.length - 3]).getHostAddress(), m.args[4],
			m.args[4], m.args[m.args.length - 1], s);
		this.protocol.parseUserModes(u, Arrays.copyOfRange(m.args, 5, m.args.length - 3));
		s.addUser(u);
		
		TheXBot.em().addUser(u);
	}

	@Override
	public void handle(Message m)
	{
		throw new UnsupportedOperationException("Handler called for unsupported source.");
	}
}
