package invalid.thexbot.protocol.darenetprotocol;

import java.util.logging.Level;
import invalid.thexbot.Logger;
import invalid.thexbot.TheXBot;
import invalid.thexbot.irc.Server;
import invalid.thexbot.irc.User;
import invalid.thexbot.protocol.Message;
import invalid.thexbot.protocol.MessageHandler;
import invalid.thexbot.protocol.Protocol;

public final class SHandler extends MessageHandler {
	public SHandler(Protocol p)
	{
		super(p, 8, SourceType.SERVER);
	}

	@Override
	public void handle(User u, Message m)
	{
		throw new UnsupportedOperationException("Handler called for unsupported source.");
	}

	@Override
	public void handle(Server s, Message m)
	{
		// [OWNING SERVER PREFIX] S [SERVERNAME] [HOPCOUNT] [START TIME] [LINK TIME] [PROTOCOL] [NUMERIC/MAXCONN] [FLAGS] :[DESCRIPTION]
		// source                   0            1          2            3           4          5                 6        7

		String sid = m.args[5].substring(0, 2);
		if (TheXBot.em().findServer(sid) != null || TheXBot.em().findServer(m.args[0]) != null) {
			Logger.getLogger(SHandler.class.getName()).log(Level.WARNING,
				"Attempted re-introduction of existing server " + m.args[0] + "/" + sid + ", dropping.");
			return;
		}

		Server server = new Server(m.args[0], m.args[7], sid, s);
		if (m.args[4].charAt(0) == 'J') {
			TheXBot.bursting = true;
		} else {
			server.finishBurst();
		}
		
		s.addDownlink(server);
		
		TheXBot.em().addServer(server);
	}

	@Override
	public void handle(Message m)
	{
		throw new UnsupportedOperationException("Handler called for unsupported source.");
	}
}
