package invalid.thexbot.protocol.darenetprotocol;

import java.util.EnumSet;
import java.util.logging.Level;
import invalid.thexbot.Logger;
import invalid.thexbot.TheXBot;
import invalid.thexbot.Util;
import invalid.thexbot.irc.Channel;
import invalid.thexbot.irc.ChannelUserStatus;
import invalid.thexbot.irc.Server;
import invalid.thexbot.irc.User;
import invalid.thexbot.protocol.Message;
import invalid.thexbot.protocol.MessageHandler;
import invalid.thexbot.protocol.Protocol;

public final class SJHandler extends MessageHandler {
	public SJHandler(Protocol p)
	{
		super(p, 2, SourceType.SERVER);
	}

	@Override
	public void handle(User u, Message m)
	{
		throw new UnsupportedOperationException("Handler called for unsupported source.");
	}

	@Override
	public void handle(Server s, Message m)
	{
		User u = TheXBot.em().findUser(m.args[0]);
		if (u == null) {
			return;
		}

		// iterate twice; once to catch any JOIN 0, twice to actually join
		int offset = -1;

		String[] chans = m.args[1].split(",");
		for (int i = 0; i < chans.length; i++) {
			if (chans[i].equals("0")) {
				offset = i;
			}
		}

		/* We got a JOIN 0 at some point; clear out any current channels and start
		 * SVSJOINing from offset
		 */
		if (offset != -1) {
			for (Channel c : u.getChannels()) {
				c.removeUser(u);
				u.part(c);

				if (c.getUsers().isEmpty() && !c.isPersistent()) {
					TheXBot.em().removeChannel(c);
				}
			}
		}

		for (int i = offset + 1; i < chans.length; i++) {
			Channel c = TheXBot.em().findChannel(chans[i]);

			if (c == null) {
				c = new Channel(chans[i], Util.getTimestamp());
				c.addUser(u, EnumSet.of(ChannelUserStatus.CHANOP));
			} else {
				c.addUser(u);
			}

			u.join(c);
		}

	}

	@Override
	public void handle(Message m)
	{
		throw new UnsupportedOperationException("Handler called for unsupported source.");
	}
}
