package invalid.thexbot.protocol.darenetprotocol;

import java.util.logging.Level;
import invalid.thexbot.Logger;
import invalid.thexbot.TheXBot;
import invalid.thexbot.irc.Server;
import invalid.thexbot.irc.User;
import invalid.thexbot.irc.UserMode;
import invalid.thexbot.protocol.Message;
import invalid.thexbot.protocol.MessageHandler;
import invalid.thexbot.protocol.Protocol;

public final class WHandler extends MessageHandler {
	public WHandler(Protocol p)
	{
		super(p, 2, SourceType.USER);
	}

	@Override
	public void handle(User whoiser, Message m)
	{
		User u = TheXBot.em().findUser(m.args[1]);

		if (TheXBot.em().findServer(m.args[0]) != this.protocol.getServer()) {
			Logger.getLogger(WHandler.class.getName()).log(Level.INFO,
				"Got W not directed to me from " + whoiser.getNumeric());
			return;
		}

		this.protocol.numeric(311, whoiser.getNumeric() + " " + u.getNick() + " " + u.getShownIdent() + " " + u.getShownHost() + " * :" + u.getGECOS());
		if (whoiser.hasMode(UserMode.OPER)) {
			this.protocol.numeric(312, whoiser.getNumeric() + " " + u.getNick() + " " + u.getServer().getName() + " :" + u.getServer().getDescription());
		} else {
			this.protocol.numeric(312, whoiser.getNumeric() + " " + u.getNick() + " " + protocol.getServer().getName() + " :" + this.protocol.getServer().getDescription());
		}

		String oper = whoiser.getNumeric() + " " + u.getNick() + " :is an IRC Operator";
		if (u.hasMode(UserMode.SERVICE)) {
			this.protocol.numeric(313, oper + " - Network Service");
		} else if (u.hasMode(UserMode.NETADMIN)) {
			this.protocol.numeric(313, oper + " - Network Administrator");
		} else if (u.hasMode(UserMode.ADMIN)) {
			this.protocol.numeric(313, oper + " - Server Administrator");
		} else if (u.hasMode(UserMode.OPER)) {
			this.protocol.numeric(313, oper);
		}
		
		if (whoiser.hasMode(UserMode.OPER)) {
			this.protocol.numeric(310, whoiser.getNumeric() + " " + u.getNick() + " :is using modes +" + this.protocol.getUserModeString(u)/* + " authflags: $=^_><|"*/);
			this.protocol.numeric(338, whoiser.getNumeric() + " " + u.getNick() + " :is actually " + u.getRealIdent() + "@" + u.getRealHost() + " ["
				+ ((u.getIP().equals("0") || u.getIP().equals("255.255.255.255")) ? "255.255.255.255" : u.getIP()) + "]");
		}
		this.protocol.numeric(317, whoiser.getNumeric() + " " + u.getNick() + " 0 " + TheXBot.start_time  + " :seconds idle, signon time");
		this.protocol.numeric(318, whoiser.getNumeric() + " " + u.getNick() + " :End of /WHOIS list.");
	}

	@Override
	public void handle(Server s, Message m)
	{
		throw new UnsupportedOperationException("Handler called for unsupported source.");
	}

	@Override
	public void handle(Message m)
	{
		throw new UnsupportedOperationException("Handler called for unsupported source.");
	}
}
